# VIVAS Viet OCR

## Training
### 1. Prepare data
Bổ sung dữ liệu vào thư mục data theo quy tắc sau: <br>
*(Xem mẫu trong thư mục data)* <br>
- Hình ảnh được lưu trong "data/images".<br>
- Nhãn được ghi trong file train_annotation.txt (dữ liệu training) và file test_annotation.txt (dữ liệu valid) chia tỷ lệ 8-2 với định dạng mỗi dòng là: "path_to_image_file   label" (cách nhau bằng dấu tab). <br>
**path_to_image_file**: đường dẫn tương đối lấy gốc từ thư mục data. <br>
**label**: dòng chữ có trong ảnh. <br>

Vd: 
```
images/20140603_0003_BCCTC_tg_0_0.png	Bản chất của thành công
images/20140603_0003_BCCTC_tg_1.png     Đã bao giờ bạn tự hỏi thành công là gì mà bao kẻ bỏ cả cuộc đời mình theo đuổi? Phải
images/20140603_0003_BCCTC_tg_12.png	chăng đó là kết quả hoàn hảo trong công việc, sự chính xác đến từng chi tiết? Hay đó
```

### 2. Config
Chỉnh sửa file **config.yml**. Các thông tin cần lưu ý:
```
dataset:
  image_height: 32
  image_max_width: 512
  image_min_width: 32

device: cuda:0

trainer:
  batch_size: 8
  iters: 20000
  metrics: 1000
  print_every: 20
  valid_every: 20
```
metrics: số mẫu được dùng để tính acc full seq và acc per char, <= len(test_annotation). <br>
test_annotation dùng để tính valid loss.

### 3. Run training
```
docker-compose -f training.docker-compose.yml up --build
```
Theo dõi kết quả trên màn hình terminal. <br>
Model sau khi train được lưu tại **"./weights"**

Sau khi train: docker system prune

## Export model Pytorch to ONNX
### 1. Config
Model pth được lưu tại **"./weights"** <br>
Chỉnh sửa file **vgg-seq2seq.yml**. Các thông tin cần lưu ý:
```
device: cuda:0

transformer:
    encoder_hidden: 256
    decoder_hidden: 256
    img_channel: 256
    decoder_embedded: 256
    dropout: 0.1
```
### 2. Run
```
docker-compose -f export.docker-compose.yml up --build
```
Model sau khi export được lưu tại **"./weights"**